transformers-0.4.2.0: Concrete functor and monad transformers

Copyright | (c) Ross Paterson 2010
License | BSD-style (see the file LICENSE)
Maintainer | ross@soi.city.ac.uk
Stability | experimental
Portability | portable
Safe Haskell | Safe
Language | Haskell98

Data.Functor.Product

Description

Products, lifted to functors.

Synopsis

- data Product f g a = Pair (f a) (g a)

# Documentation

data Product f g a Source

Lifted product of functors.

Constructors

Pair (f a) (g a) |

Instances

(Monad f, Monad g) => Monad (Product f g) |
(Functor f, Functor g) => Functor (Product f g) |
(MonadFix f, MonadFix g) => MonadFix (Product f g) |
(Applicative f, Applicative g) => Applicative (Product f g) |
(Foldable f, Foldable g) => Foldable (Product f g) |
(Traversable f, Traversable g) => Traversable (Product f g) |
(Alternative f, Alternative g) => Alternative (Product f g) |
(MonadPlus f, MonadPlus g) => MonadPlus (Product f g) |
(Show1 f, Show1 g) => Show1 (Product f g) |
(Read1 f, Read1 g) => Read1 (Product f g) |
(Ord1 f, Ord1 g) => Ord1 (Product f g) |
(Eq1 f, Eq1 g) => Eq1 (Product f g) |
(Eq1 f, Eq1 g, Eq a) => Eq (Product f g a) |
(Ord1 f, Ord1 g, Ord a) => Ord (Product f g a) |
(Read1 f, Read1 g, Read a) => Read (Product f g a) |
(Show1 f, Show1 g, Show a) => Show (Product f g a) |